"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.NamespaceContext = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

const NamespaceContext = (0, _react.createContext)({});
exports.NamespaceContext = NamespaceContext;

class Namespace extends _react.Component {
  getPath() {
    const {
      path,
      compose,
      namespace
    } = this.props;

    if (!compose || !path) {
      return path;
    }

    if (namespace) {
      const parentPath = namespace.getPath();

      if (parentPath) {
        return `${parentPath}.${path}`;
      }
    }

    return path;
  }

  render() {
    const {
      children
    } = this.props;
    return _react.default.createElement(NamespaceContext.Provider, {
      value: {
        namespace: this
      }
    }, children);
  }

}

(0, _defineProperty2.default)(Namespace, "defaultProps", {
  path: undefined,
  compose: undefined,
  namespace: undefined
});

var _default = (0, _react.forwardRef)((props, ref) => _react.default.createElement(NamespaceContext.Consumer, null, ({
  namespace
}) => _react.default.createElement(Namespace, (0, _extends2.default)({}, props, {
  namespace: namespace,
  ref: ref
}))));

exports.default = _default;
//# sourceMappingURL=Namespace.js.map